## svt-av1 2.3.0+dfsg

=== CMakeLists.txt ===
#
# Copyright(c) 2018 Intel Corporation
#
# This source code is subject to the terms of the BSD 2 Clause License and
# the Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

cmake_minimum_required(VERSION 3.16)

if("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    message(WARNING "Building in-source is highly not recommended\n"
                    "Please use the Build folder or create your own.")
endif()

project(svt-av1 VERSION 2.3.0
    LANGUAGES C CXX)

set(VERSION_TAG "")

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0069)
    cmake_policy(SET CMP0069 NEW)
endif()
if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()


set(CMAKE_C_VISIBILITY_PRESET hidden)
# Default build type to release if the generator does not has its own set of build types
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE Release)
endif()

if(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message(WARNING "32-bit is not supported")
endif()

option(COMPILE_C_ONLY "Compile only C code with no simds (autodetect, default off for x86)" OFF)
option(USE_EXTERNAL_CPUINFO "Consume system cpuinfo library only" OFF)

if(USE_EXTERNAL_CPUINFO)
    find_package(cpuinfo CONFIG REQUIRED)
endif()

include(CheckCSourceCompiles)

check_c_source_compiles("
#if defined(_M_X64) || defined(__x86_64__)
#else
#error \"Non-x64\"
#endif
int main(void) {}
" HAVE_X86_PLATFORM)

check_c_source_compiles("
#if defined(__aarch64__) || defined(_M_ARM64)
#else
#error \"Non-arm64\"
#endif
int main(void) {}
" HAVE_ARM_PLATFORM)

option(MINIMAL_BUILD "Enable minimal build" OFF)
if(MINIMAL_BUILD)
    add_definitions(-DMINIMAL_BUILD=1)
endif()

if(NOT COMPILE_C_ONLY AND HAVE_X86_PLATFORM)
    include(CheckLanguage)
    check_language(ASM_NASM)
    if(CMAKE_ASM_NASM_COMPILER MATCHES "nasm")
        set(NASM_VERSION "0.0.0")
        execute_process(COMMAND ${CMAKE_ASM_NASM_COMPILER} -v
            OUTPUT_VARIABLE NASM_VERSION
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        string(REGEX MATCH "([.0-9])+" NASM_VERSION "${NASM_VERSION}")
        # NASM_VERSION should now contain something like 2.14.02
        # Needs to error out on a version less than 2.14
        if(NASM_VERSION VERSION_LESS "2.14")
            find_program(YASM_EXE yasm)
            if(YASM_EXE)
                set(CMAKE_ASM_NASM_COMPILER ${YASM_EXE})
                message(STATUS "Found nasm is too old (requires at least 2.14, found ${NASM_VERSION}), using yasm instead")
            else()
                message(FATAL_ERROR "Found nasm is too old (requires at least 2.14, found ${NASM_VERSION})!")
            endif()
        endif()
    endif()
    enable_language(ASM_NASM)
    add_definitions(-DARCH_X86_64=1)
elseif(NOT COMPILE_C_ONLY AND HAVE_ARM_PLATFORM)
    set(ARM64_FLAVORS "NEON;ARM_CRC32;NEON_DOTPROD;NEON_I8MM;SVE;SVE2")
    set(ARM_CRC32_DEFAULT_FLAG "-march=armv8-a+crc")
    set(NEON_DOTPROD_DEFAULT_FLAG "-march=armv8.2-a+dotprod")
    set(NEON_I8MM_DEFAULT_FLAG "-march=armv8.2-a+dotprod+i8mm")
    set(SVE_DEFAULT_FLAG "-march=armv8.2-a+dotprod+i8mm+sve")
    set(SVE2_DEFAULT_FLAG "-march=armv9-a+i8mm+sve2") # SVE2 is a v9-only feature

    option(ENABLE_NEON "Enables Neon optimizations on AArch64 targets." ON)
    option(ENABLE_ARM_CRC32 "Enables Arm CRC32 optimizations." ON)
    option(ENABLE_NEON_DOTPROD
      "Enables Armv8.2-A Neon DotProd optimizations on AArch64 targets." ON)
    option(ENABLE_NEON_I8MM
      "Enables Armv8.2-A Neon I8MM optimizations on AArch64 targets." ON)
    option(ENABLE_SVE "Enables Armv8.2-A SVE optimizations on AArch64 targets." ON)
    option(ENABLE_SVE2 "Enables Armv9-A SVE2 optimizations on AArch64 targets." ON)

    # Check that the compiler flag to enable each flavor is supported by the
    # compiler. This may not be the case for new architecture features on old
    # compiler versions.
    set(C_MAIN "\nint main(void) { return 0; }")
    foreach(flavor ${ARM64_FLAVORS})
        if(ENABLE_${flavor} AND NOT DEFINED ${flavor}_FLAG)
            set(${flavor}_FLAG "${${flavor}_DEFAULT_FLAG}")

            # Do not use check_c_compiler_flag here since the regex used to match
            # against stderr does not recognise the "invalid feature modifier" error
            # produced by certain versions of GCC, leading to the feature being
            # incorrectly marked as available.
            set(OLD_CMAKE_REQURED_FLAGS ${CMAKE_REQUIRED_FLAGS})
            set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${${flavor}_FLAG}")
            unset(${flavor}_FLAG_SUPPORTED)
            check_c_source_compiles("static void function(void) {} ${C_MAIN}" ${flavor}_FLAG_SUPPORTED)
            set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})

            if(NOT ${flavor}_FLAG_SUPPORTED)
              set(ENABLE_${flavor} 0)
            endif()
        endif()
    endforeach()

    # SVE and SVE2 require that the Neon-SVE bridge header is also available.
    if(ENABLE_SVE OR ENABLE_SVE2)
        set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
        set(OLD_CMAKE_TRY_COMPILE_TARGET_TYPE ${CMAKE_TRY_COMPILE_TARGET_TYPE})
        set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${SVE_FLAG}")
        set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
        check_c_source_compiles("
#ifndef __ARM_NEON_SVE_BRIDGE
#error 1
#endif
#include <arm_sve.h>
#include <arm_neon_sve_bridge.h>" HAVE_SVE_HEADERS)
        # Check whether the compiler can compile SVE functions that require
        # backup/restore of SVE registers according to AAPCS. Clang for Windows used
        # to fail this, see https://github.com/llvm/llvm-project/issues/80009.
        check_c_source_compiles("
#include <arm_sve.h>
void other(void);
svfloat32_t func(svfloat32_t a) {
  other();
  return a;
} ${C_MAIN}" CAN_COMPILE_SVE)
        set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})
        set(CMAKE_TRY_COMPILE_TARGET_TYPE ${OLD_CMAKE_TRY_COMPILE_TARGET_TYPE})
        if(NOT HAVE_SVE_HEADERS OR NOT CAN_COMPILE_SVE)
            set(ENABLE_SVE 0)
            set(ENABLE_SVE2 0)
        endif()
    endif()

    foreach(flavor ${ARM64_FLAVORS})
        if(ENABLE_${flavor})
            add_compile_definitions(HAVE_${flavor}=1)
        else()
            add_compile_definitions(HAVE_${flavor}=0)
        endif()
    endforeach()

    add_definitions(-DARCH_AARCH64=1)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-lax-vector-conversions")
endif()

include(GNUInstallDirs)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

set(CMAKE_OUTPUT_DIRECTORY "${PROJECT_SOURCE_DIR}/Bin/${CMAKE_BUILD_TYPE}/" CACHE PATH "Location to write the resulting binaries to")

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})

#Clang support, required to build static with LTO
if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND UNIX AND NOT APPLE)
    find_program(LLVM_LD_EXE llvm-ld)
    find_program(LLVM_AR_EXE llvm-ar)
    find_program(LLVM_RANLIB_EXE llvm-ranlib)
    if(LLVM_LD_EXE)
        SET (CMAKE_LINKER  "llvm-ld")
    endif()
    if(LLVM_AR_EXE)
        SET (CMAKE_AR      "llvm-ar")
    endif()
    if(LLVM_RANLIB_EXE)
        SET (CMAKE_RANLIB  "llvm-ranlib")
    endif()
endif()

if(MSVC)
    if(DEFINED SANITIZER)
        message(WARNING "Sanitizers are not available with MSVC currently")
    endif()
    unset(SANITIZER)
    unset(SANITIZER CACHE)
else()
    set(SANITIZER "" CACHE STRING "Sanitizer to enable. Currently known values are Address, Memory, Thread, Undefined, and Integer")
    set_property(CACHE SANITIZER PROPERTY STRINGS Address Memory Thread Undefined Integer)
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 11)

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
# make it prominent in the GUI.
option(BUILD_SHARED_LIBS "Build shared libraries (DLLs)." ON)
message(STATUS "BUILD_SHARED_LIBS: ${BUILD_SHARED_LIBS}")

option(BUILD_TESTING "Build SvtAv1UnitTests, SvtAv1ApiTests, and SvtAv1E2ETests unit tests")
option(COVERAGE "Generate coverage report")
if(NOT MSVC)
    option(SVT_AV1_PGO "Enable profile guided optimization. Creates the RunPGO and CompilePGO targets")
    # options for internal use
    option(SVT_INTERNAL_PGO_GENERATE "Generate a profile guided optimization profile")
    option(SVT_INTERNAL_PGO_USE "Use a profile for profile guided optimization")
    mark_as_advanced(SVT_INTERNAL_PGO_GENERATE SVT_INTERNAL_PGO_USE)
    set(SVT_AV1_PGO_DIR "${CMAKE_BINARY_DIR}" CACHE PATH "Path to the directory passed to -fprofile-dir for use with profile guided optimization")
    set(SVT_AV1_PGO_CUSTOM_VIDEOS "" CACHE STRING "Semi-colon separated list of directories with y4m videos to run PGO on instead of objective-1-fast")
else()
    set(SVT_AV1_PGO OFF)
endif()

if(MSVC AND SVT_AV1_PGO)
    message(WARNING "PGO is not yet supported for MSVC, disabling")
    unset(SVT_AV1_PGO)
    unset(SVT_AV1_PGO CACHE)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND SVT_AV1_PGO)
    find_program(LLVM_PROFDATA llvm-profdata)
    if(NOT LLVM_PROFDATA)
        message(FATAL_ERROR "llvm-profdata not found.")
    endif()
endif()

option(BUILD_APPS "Build Enc Apps" ON)
option(EXCLUDE_HASH "Disables the use of the git hash in the build to produce hash exact binaries, implies REPRODUCIBLE_BUILDS")
option(REPRODUCIBLE_BUILDS "Disable use of certain C macros to always generate reproducable builds" ${EXCLUDE_HASH})
if(SVT_AV1_PGO AND NOT BUILD_APPS)
    message(FATAL_ERROR "Can't use pgo and not build the apps")
endif()

if(SVT_INTERNAL_PGO_USE)
    if(MSVC)
        set(PGO_COMPILER_FLAGS "/GL")
        set(PGO_LINKER_FLAGS "/LTCG /USEPROFILE")
    else()
        set(PGO_COMPILER_FLAGS "-fprofile-use=${SVT_AV1_PGO_DIR}")
        set(PGO_LINKER_FLAGS "-fprofile-use=${SVT_AV1_PGO_DIR}")
        if (CMAKE_C_COMPILER_ID STREQUAL "GNU") # GCC
            # We want unprofiled code optimised for speed, not size, so we mark the profiling data as "partial".
            set(PGO_COMPILER_FLAGS "${PGO_COMPILER_FLAGS} -fprofile-correction -fprofile-partial-training")
            set(PGO_LINKER_FLAGS "${PGO_LINKER_FLAGS} -fprofile-correction -fprofile-partial-training")
        endif()
    endif()
elseif(SVT_INTERNAL_PGO_GENERATE)
    if(MSVC)
        set(PGO_COMPILER_FLAGS "/GL")
        set(PGO_LINKER_FLAGS "/LTCG /GENPROFILE")
    else()
        set(PGO_COMPILER_FLAGS "-fprofile-generate=${SVT_AV1_PGO_DIR}")
        set(PGO_LINKER_FLAGS "-fprofile-generate=${SVT_AV1_PGO_DIR}")
    endif()
endif()

if(SVT_AV1_PGO)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${PGO_COMPILER_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PGO_COMPILER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${PGO_LINKER_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${PGO_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${PGO_LINKER_FLAGS}")
endif()

if(EXCLUDE_HASH)
    add_link_options(-Wl,--build-id=none)
    add_definitions(-DEXCLUDE_HASH=1)
else()
    add_definitions(-DEXCLUDE_HASH=0)
endif()

if(REPRODUCIBLE_BUILDS)
    add_definitions(-DREPRODUCIBLE_BUILDS=1)
else()
    add_definitions(-DREPRODUCIBLE_BUILDS=0)
endif()


if(WIN32)
    set(CMAKE_ASM_NASM_FLAGS "${CMAKE_ASM_NASM_FLAGS} -DWIN64")
else()
    set(CMAKE_ASM_NASM_FLAGS "${CMAKE_ASM_NASM_FLAGS} -DUNIX64")
endif()

if(UNIX)
    if(APPLE)
        set(CMAKE_MACOSX_RPATH 1)
        if(CMAKE_C_COMPILER_ID MATCHES "AppleClang")

=== test/CMakeLists.txt ===
#
# Copyright(c) 2019 Netflix, Inc.
#
# This source code is subject to the terms of the BSD 2 Clause License and the
# Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License was
# not distributed with this source code in the LICENSE file, you can obtain it
# at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at
# https://www.aomedia.org/license/patent-license.
#

# APP Directory CMakeLists.txt

# Include Subdirectories
include_directories(
  ${PROJECT_SOURCE_DIR}/test/
  ${PROJECT_SOURCE_DIR}/test/ref
  ${PROJECT_SOURCE_DIR}/third_party/googletest/include
  third_party/googletest/src
  ${PROJECT_SOURCE_DIR}/Source/API
  ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE2/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSSE3/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE4_1/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX2/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX512/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/
  ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE/
  ${PROJECT_SOURCE_DIR}/Source/Lib/Codec
  ${PROJECT_SOURCE_DIR}/Source/Lib/Globals
  ${PROJECT_SOURCE_DIR}/Source/App
  ${PROJECT_SOURCE_DIR}/Source/API
  ${PROJECT_SOURCE_DIR}/third_party/fastfeat/
  ${PROJECT_SOURCE_DIR}/third_party/aom_dsp/inc/)

# Define helper functions and macros used by Google Test.
include(../third_party/googletest/cmake/internal_utils.cmake)

if(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_ALLOW_KEYWORD_MACROS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_ALLOW_KEYWORD_MACROS")
endif()

# When other libraries are using a shared version of runtime libraries, Google
# Test also has to use one.
option(
  gtest_force_shared_crt
  "Use shared (DLL) run-time lib even when Google Test is built as static lib."
  OFF)

add_definitions(-D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING=1)

enable_testing()

if(UNIX AND HAVE_X86_PLATFORM)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mavx2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2")
endif()

set(arch_neutral_files
    BitstreamWriterTest.cc
    unit_test.h
    unit_test_utility.c
    unit_test_utility.h
    FilmGrainExpectedResult.h
    FilmGrainTest.cc
    GlobalMotionUtilTest.cc
    IntraBcUtilTest.cc
    ResizeTest.cc
    TestEnv.c
    TxfmCommon.h
    acm_random.h
    random.h
    util.h
    ref/TxfmRef.cc
    ref/TxfmRef.h
    ssim_test.cc
    svt_av1_test.cc
    ../third_party/aom_dsp/src/bitreader.c
    ../third_party/aom_dsp/src/entdec.c)

set(multi_arch_files
    AdaptiveScanTest.cc
    BlockErrorTest.cc
    CdefTest.cc
    CompoundUtilTest.cc
    Convolve8Test.cc
    DeblockTest.cc
    EncodeTxbAsmTest.cc
    FilterIntraPredTest.cc
    FwdTxfm2dAsmTest.cc
    HbdVarianceTest.cc
    InvTxfm2dAsmTest.cc
    OBMCSadTest.cc
    OBMCVarianceTest.cc
    PackUnPackTest.cc
    PictureOperatorTest.cc
    QuantAsmTest.cc
    ResidualTest.cc
    RestorationPickTest.cc
    SadTest.cc
    SatdTest.cc
    SelfGuidedUtilTest.cc
    SpatialFullDistortionTest.cc
    TemporalFilterTestPlanewise.cc
    VarianceTest.cc
    WedgeUtilTest.cc
    convolve_test.cc
    hadamard_test.cc
    intrapred_cfl_test.cc
    intrapred_dr_test.cc
    intrapred_test.cc
    quantize_func_test.cc
    selfguided_filter_test.cc
    warp_filter_test.cc
    warp_filter_test_util.cc
    warp_filter_test_util.h
    wiener_convolve_test.cc)

if(HAVE_X86_PLATFORM)
  set(x86_arch_files
      noise_model_test.cc
      highbd_intra_prediction_tests.cc
      highbd_intra_prediction_tests.h
      FFTTest.cc
      ForwardtransformTests.cc
      FwdTxfm1dTest.cc
      InvTxfm1dTest.cc
      FwdTxfm2dTest.cc
      MotionEstimationTest.cc
      PaletteModeUtilTest.cc
      PsnrTest.cc
      av1_convolve_scale_test.cc
      compute_mean_test.cc
      corner_match_test.cc
      dwt_test.cc
      frame_error_test.cc
      intrapred_edge_filter_test.cc
      subtract_avg_cfl_test.cc)
endif()

if(HAVE_ARM_PLATFORM)
  set(arm_arch_files)
endif()

set(arch_neutral_lib_list
    $<TARGET_OBJECTS:FASTFEAT>
    $<TARGET_OBJECTS:C_DEFAULT>
    $<TARGET_OBJECTS:GLOBALS>
    $<TARGET_OBJECTS:CODEC>
    gtest_all)

if(HAVE_X86_PLATFORM)
  set(x86_arch_lib_list
      $<TARGET_OBJECTS:ASM_SSE2>
      $<TARGET_OBJECTS:ASM_SSSE3>
      $<TARGET_OBJECTS:ASM_SSE4_1>
      $<TARGET_OBJECTS:ASM_AVX2>
      $<IF:$<BOOL:${USE_EXTERNAL_CPUINFO}>,cpuinfo::cpuinfo,cpuinfo_public>)
  if(ENABLE_AVX512)
    list(APPEND x86_arch_lib_list
      $<TARGET_OBJECTS:ASM_AVX512>)
  endif()
endif()

if(HAVE_ARM_PLATFORM)
  set(arm_arch_lib_list $<TARGET_OBJECTS:ASM_NEON>)
  if(ENABLE_NEON_DOTPROD)
    list(APPEND arm_arch_lib_list $<TARGET_OBJECTS:ASM_NEON_DOTPROD>)
  endif()
  if(ENABLE_NEON_I8MM)
    list(APPEND arm_arch_lib_list $<TARGET_OBJECTS:ASM_NEON_I8MM>)
  endif()
  if(ENABLE_SVE)
    list(APPEND arm_arch_lib_list $<TARGET_OBJECTS:ASM_SVE>)
  endif()
  if(ENABLE_SVE2)
    list(APPEND arm_arch_lib_list $<TARGET_OBJECTS:ASM_SVE2>)
  endif()
endif()

set(all_files ${arch_neutral_files} ${multi_arch_files} ${x86_arch_files}
              ${arm_arch_files})

set(lib_list ${arch_neutral_lib_list} ${x86_arch_lib_list} ${arm_arch_lib_list})

if(UNIX)
  # App Source Files
  add_executable(SvtAv1UnitTests ${all_files})
  # Link the Encoder App
  target_link_libraries(SvtAv1UnitTests ${lib_list} pthread m)
else()
  cxx_executable_with_flags(SvtAv1UnitTests "${cxx_default}" "${lib_list}"
                            ${all_files})
endif()

add_dependencies(SvtAv1UnitTests SvtAv1Enc)

install(TARGETS SvtAv1UnitTests RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_test(SvtAv1UnitTests ${CMAKE_OUTPUT_DIRECTORY}/SvtAv1UnitTests)

add_subdirectory(api_test)
add_subdirectory(e2e_test)

=== third_party/cpuinfo/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0069)
  cmake_policy(SET CMP0069 NEW)
endif()

INCLUDE(GNUInstallDirs)

# ---[ Options.
SET(CPUINFO_RUNTIME_TYPE "default" CACHE STRING "Type of runtime library (shared, static, or default) to use")
SET_PROPERTY(CACHE CPUINFO_RUNTIME_TYPE PROPERTY STRINGS default static shared)
SET(CPUINFO_LOG_LEVEL "default" CACHE STRING "Minimum logging level (info with lower severity will be ignored)")
SET_PROPERTY(CACHE CPUINFO_LOG_LEVEL PROPERTY STRINGS default debug info warning error fatal none)

MACRO(CPUINFO_TARGET_ENABLE_C99 target)
  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
    IF(NOT MSVC)
      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c99)
    ENDIF()
  ELSE()
    SET_TARGET_PROPERTIES(${target} PROPERTIES
      C_STANDARD 99
      C_EXTENSIONS NO)
  ENDIF()
ENDMACRO()

MACRO(CPUINFO_TARGET_ENABLE_CXX11 target)
  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
    IF(NOT MSVC)
      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c++11)
    ENDIF()
  ELSE()
    SET_TARGET_PROPERTIES(${target} PROPERTIES
      CXX_STANDARD 11
      CXX_EXTENSIONS NO)
  ENDIF()
ENDMACRO()

MACRO(CPUINFO_TARGET_RUNTIME_LIBRARY target)
  IF(MSVC AND NOT CPUINFO_RUNTIME_TYPE STREQUAL "default")
    IF(CPUINFO_RUNTIME_TYPE STREQUAL "shared")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MD$<$<CONFIG:Debug>:d>")
    ELSEIF(CPUINFO_RUNTIME_TYPE STREQUAL "static")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MT$<$<CONFIG:Debug>:d>")
    ENDIF()
  ENDIF()
ENDMACRO()

# ---[ Build flags
SET(CPUINFO_SUPPORTED_PLATFORM TRUE)
IF(NOT CMAKE_SYSTEM_PROCESSOR)
  IF(NOT IOS)
    MESSAGE(WARNING
      "Target processor architecture is not specified. "
      "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
    SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
  ENDIF()
ELSEIF(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|amd64|x86(_64)?|armv[5-8].*|aarch64|arm64)$")
  MESSAGE(WARNING
    "Target processor architecture \"${CMAKE_SYSTEM_PROCESSOR}\" is not supported in cpuinfo. "
    "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
  SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
ENDIF()

IF(NOT CMAKE_SYSTEM_NAME)
    MESSAGE(WARNING
      "Target operating system is not specified. "
      "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
  SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS|Darwin|Linux|Android|DragonFly|FreeBSD|NetBSD|OpenBSD)$")
  IF(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.14" AND NOT CMAKE_SYSTEM_NAME STREQUAL "iOS")
    MESSAGE(WARNING
      "Target operating system \"${CMAKE_SYSTEM_NAME}\" is not supported in cpuinfo. "
      "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
    SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
  ENDIF()
ENDIF()

# ---[ cpuinfo library
SET(CPUINFO_SRCS
  src/init.c
  src/api.c)

IF(CPUINFO_SUPPORTED_PLATFORM)
  IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten" AND (CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|amd64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$"))
    LIST(APPEND CPUINFO_SRCS
      src/x86/x86_init.c
      src/x86/vendor.c
      src/x86/isa.c)
    IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
      LIST(APPEND CPUINFO_SRCS
        src/x86/linux/init.c)
    ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(DragonFly|FreeBSD|NetBSD|OpenBSD)$")
      LIST(APPEND CPUINFO_SRCS src/x86/bsd/init.c)
    ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" OR CMAKE_SYSTEM_NAME STREQUAL "iOS")
      LIST(APPEND CPUINFO_SRCS src/x86/mach/x86_mach_init.c)
    ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$")
      LIST(APPEND CPUINFO_SRCS src/x86/windows/init.c)
    ENDIF()
  ENDIF()

  IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android" OR CMAKE_SYSTEM_NAME MATCHES "^(DragonFly|FreeBSD|NetBSD|OpenBSD)$")
    SET(CMAKE_THREAD_PREFER_PTHREAD TRUE)
    SET(THREADS_PREFER_PTHREAD_FLAG TRUE)
    FIND_PACKAGE(Threads REQUIRED)
  ENDIF()
ENDIF()

ADD_LIBRARY(cpuinfo OBJECT ${CPUINFO_SRCS})

CPUINFO_TARGET_ENABLE_C99(cpuinfo)

INCLUDE_DIRECTORIES(deps/clog/include)

SET_PROPERTY(TARGET cpuinfo PROPERTY POSITION_INDEPENDENT_CODE ON)

CPUINFO_TARGET_RUNTIME_LIBRARY(cpuinfo)
IF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$")
  # Target Windows 7+ API
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE _WIN32_WINNT=0x0601)
ENDIF()
SET_TARGET_PROPERTIES(cpuinfo PROPERTIES PUBLIC_HEADER include/cpuinfo.h)
TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PUBLIC include)
TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PRIVATE src)
IF(CPUINFO_LOG_LEVEL STREQUAL "default")
  # default logging level: error (subject to change)
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=2)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "debug")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=5)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "info")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=4)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "warning")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=3)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "error")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=2)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "fatal")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=1)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "none")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=0)
ELSE()
  MESSAGE(FATAL_ERROR "Unsupported logging level ${CPUINFO_LOG_LEVEL}")
ENDIF()

IF(CPUINFO_SUPPORTED_PLATFORM)
  TARGET_COMPILE_DEFINITIONS(cpuinfo INTERFACE CPUINFO_SUPPORTED_PLATFORM=1)
  IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
    TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE _GNU_SOURCE=1)
  ENDIF()
ELSE()
  TARGET_COMPILE_DEFINITIONS(cpuinfo INTERFACE CPUINFO_SUPPORTED_PLATFORM=0)
ENDIF()

# ---[ cpuinfo dependencies: clog
IF(NOT DEFINED CLOG_SOURCE_DIR)
  SET(CLOG_SOURCE_DIR "deps/clog")
ENDIF()
IF(NOT TARGET clog)
  SET(CLOG_BUILD_TESTS OFF CACHE BOOL "")
  SET(CLOG_RUNTIME_TYPE "${CPUINFO_RUNTIME_TYPE}" CACHE STRING "")
  ADD_SUBDIRECTORY(
    "${CLOG_SOURCE_DIR}")
  # We build static version of clog but a dynamic library may indirectly depend on it
  SET_PROPERTY(TARGET clog PROPERTY POSITION_INDEPENDENT_CODE ON)
ENDIF()

ADD_LIBRARY(cpuinfo_public INTERFACE)
TARGET_SOURCES(cpuinfo_public INTERFACE
    $<TARGET_OBJECTS:cpuinfo>
    $<TARGET_OBJECTS:clog>)

=== Source/Lib/ASM_SVE/CMakeLists.txt ===
#
# Copyright (c) 2024, Alliance for Open Media. All rights reserved
#
# This source code is subject to the terms of the BSD 2 Clause License and the
# Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License was
# not distributed with this source code in the LICENSE file, you can obtain it
# at www.aomedia.org/license/software. If the Alliance for Open Media Patent
# License 1.0 was not distributed with this source code in the PATENTS file, you
# can obtain it at www.aomedia.org/license/patent.
#

# ASM_SVE Directory CMakeLists.txt

# Include Encoder Subdirectories
enable_language(ASM) # needed for .S files
add_library(ASM_SVE OBJECT)

check_both_flags_add(-march=armv8.2-a+dotprod+i8mm+sve)

target_sources(
  ASM_SVE
  PUBLIC highbd_convolve_sve.c
  PUBLIC highbd_jnt_convolve_sve.c
  PUBLIC highbd_pickrst_sve.c
  PUBLIC highbd_variance_sve.c
  PUBLIC pickrst_sve.c)

target_include_directories(
  ASM_SVE
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/API/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE/)

=== Source/Lib/Codec/CMakeLists.txt ===
#
# Copyright(c) 2019 Intel Corporation
#
# This source code is subject to the terms of the BSD 2 Clause License and
# the Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

# Codec Directory CMakeLists.txt

if(EXCLUDE_HASH)
    set(PACKAGE_VERSION_STRING ${PROJECT_VERSION}${VERSION_TAG})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/EbVersion.h.in EbVersion.h @ONLY)
    add_custom_target(EbVersionHeaderGen)
else()
    add_custom_target(EbVersionHeaderGen
        ${CMAKE_COMMAND}
            -D INPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/EbVersion.h.in
            -D OUTPUT_FILE=EbVersion.h
            -D GIT_ROOT_DIR=${PROJECT_SOURCE_DIR}
            -D PACKAGE_VERSION_STRING=${PROJECT_VERSION}${VERSION_TAG}
            -P ${CMAKE_CURRENT_SOURCE_DIR}/ConfigureGitVersion.cmake
        BYPRODUCTS EbVersion.h
        COMMENT "Generating version header"
        VERBATIM)
endif()

if(NOT COMPILE_C_ONLY AND HAVE_X86_PLATFORM)
# Include Encoder Subdirectories
include_directories(${PROJECT_SOURCE_DIR}/Source/API/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Globals/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
    ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE2/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSSE3/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE4_1/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX2/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX512/
    ${PROJECT_SOURCE_DIR}/third_party/fastfeat/
    ${PROJECT_SOURCE_DIR}/third_party/cpuinfo/include/)
elseif(NOT COMPILE_C_ONLY AND HAVE_ARM_PLATFORM)
include_directories(${PROJECT_SOURCE_DIR}/Source/API/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Globals/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
    ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON_DOTPROD/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON_I8MM/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SVE2/
    ${PROJECT_SOURCE_DIR}/third_party/fastfeat/
    ${PROJECT_SOURCE_DIR}/third_party/cpuinfo/include/)
else ()
# Include Encoder Subdirectories
include_directories(${PROJECT_SOURCE_DIR}/Source/API/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Globals/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
    ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
    ${PROJECT_SOURCE_DIR}/third_party/fastfeat/
    ${PROJECT_SOURCE_DIR}/third_party/cpuinfo/include/)
endif ()

set(all_files
        adaptive_mv_pred.c
        adaptive_mv_pred.h
        aom_dsp_rtcd.c
        aom_dsp_rtcd.h
        av1_common.h
        av1_structs.h
        av1me.c
        av1me.h
        bitstream_unit.c
        bitstream_unit.h
        blend_a64_mask.c
        block_structures.c
        block_structures.h
        cabac_context_model.c
        cabac_context_model.h
        cdef.c
        cdef.h
        cdef_process.c
        cdef_process.h
        coding_loop.c
        coding_loop.h
        coding_unit.c
        coding_unit.h
        coefficients.h
        common_dsp_rtcd.c
        common_dsp_rtcd.h
        common_utils.h
        compute_mean.h
        compute_sad.h
        convolve.c
        convolve.h
        corner_detect.c
        corner_detect.h
        corner_match.c
        corner_match.h
        deblocking_common.c
        deblocking_common.h
        deblocking_filter.c
        deblocking_filter.h
        definitions.h
        dlf_process.c
        dlf_process.h
        dwt.c
        dwt.h
        enc_cdef.c
        enc_cdef.h
        enc_dec_process.c
        enc_dec_process.h
        enc_dec_results.c
        enc_dec_results.h
        enc_dec_segments.c
        enc_dec_segments.h
        enc_dec_tasks.c
        enc_dec_tasks.h
        enc_inter_prediction.c
        enc_inter_prediction.h
        enc_intra_prediction.c
        enc_intra_prediction.h
        enc_mode_config.c
        enc_mode_config.h
        enc_warped_motion.c
        enc_warped_motion.h
        encode_context.c
        encode_context.h
        encoder.h
        entropy_coding.c
        entropy_coding.h
        ec_object.h
        ec_process.c
        ec_process.h
        ec_results.c
        ec_results.h
        fft.c
        fft_common.h
        filter.h
        firstpass.c
        firstpass.h
        full_loop.c
        full_loop.h
        global_motion.c
        global_motion.h
        global_me.c
        global_me.h
        global_me_cost.c
        global_me_cost.h
        grainSynthesis.c
        grainSynthesis.h
        hash.c
        hash.h
        hash_motion.c
        hash_motion.h
        initial_rc_process.c
        initial_rc_process.h
        initial_rc_reorder_queue.c
        initial_rc_reorder_queue.h
        initial_rc_results.c
        initial_rc_results.h
        inter_prediction.c
        inter_prediction.h
        intra_prediction.c
        intra_prediction.h
        inv_transforms.c
        inv_transforms.h
        k_means_template.h
        lambda_rate_tables.h
        mathutils.h
        mcomp.c
        mcomp.h
        md_rate_estimation.c
        md_rate_estimation.h
        me_sad_calculation.c
        me_sad_calculation.h
        mode_decision.c
        mode_decision.h
        md_config_process.c
        md_config_process.h
        md_process.c
        md_process.h
        motion_estimation.c
        motion_estimation.h
        me_context.c
        me_context.h
        me_process.c
        me_process.h
        me_results.c
        me_results.h
        me_sb_results.h
        motion_vector_unit.h
        mv.h
        neighbor_arrays.c
        neighbor_arrays.h
        noise_model.c
        noise_model.h
        noise_util.c
        noise_util.h
        object.h
        packetization_process.c
        packetization_process.h
        packetization_reorder_queue.c
        packetization_reorder_queue.h
        palette.c
        pass2_strategy.c
        pass2_strategy.h
        pic_analysis_process.c
        pic_analysis_process.h
        pic_analysis_results.c
        pic_analysis_results.h
        pic_buffer_desc.c
        pic_buffer_desc.h
        pcs.c
        pcs.h
        pd_process.c
        pd_process.h
        pd_queue.c
        pd_queue.h
        pd_reorder_queue.c
        pd_reorder_queue.h
        pd_results.c
        pd_results.h
        pic_demux_results.c
        pic_demux_results.h
        pic_manager_process.c
        pic_manager_process.h
        pic_manager_queue.c
        pic_manager_queue.h
        pic_operators.c
        pic_operators.h
        pred_structure.c
        pred_structure.h
        product_coding_loop.c
        q_matrices.h
        random.h
        ransac.c
        ransac.h
        rc_process.c
        rc_process.h
        rc_results.c
        rc_results.h
        rc_tasks.c
        rc_tasks.h
        rd_cost.c
        rd_cost.h
        reference_object.c
        reference_object.h
        resize.c
        resize.h
        resource_coordination_process.c
        resource_coordination_process.h
        resource_coordination_results.c
        resource_coordination_results.h
        rest_process.c
        rest_process.h
        restoration.c
        restoration.h
        restoration_pick.c
        restoration_pick.h
        segmentation.c
        segmentation.h
        segmentation_params.c
        segmentation_params.h
        sequence_control_set.c
        sequence_control_set.h
        src_ops_process.c
        src_ops_process.h
        super_res.c
        super_res.h
        svt_log.c
        svt_log.h
        svt_malloc.c
        svt_malloc.h
        svt_psnr.c
        svt_psnr.h
        svt_threads.c
        svt_threads.h
        svt_time.c
        svt_time.h
        sys_resource_manager.c
        sys_resource_manager.h
        temporal_filtering.c
        temporal_filtering.h
        transforms.c
        transforms.h
        utility.c
        utility.h
        vector.c
        vector.h
        warped_motion.c
        warped_motion.h
        )

add_library(CODEC OBJECT ${all_files})

=== third_party/cpuinfo/deps/clog/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1 FATAL_ERROR)

INCLUDE(GNUInstallDirs)

# ---[ Project and semantic versioning.
PROJECT(clog C CXX)

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0069)
  cmake_policy(SET CMP0069 NEW)
endif()

# ---[ Options.
SET(CLOG_RUNTIME_TYPE "default" CACHE STRING "Type of runtime library (shared, static, or default) to use")
SET_PROPERTY(CACHE CLOG_RUNTIME_TYPE PROPERTY STRINGS default static shared)
IF(ANDROID)
  OPTION(CLOG_LOG_TO_STDIO "Log errors, warnings, and information to stdout/stderr" OFF)
ELSE()
  OPTION(CLOG_LOG_TO_STDIO "Log errors, warnings, and information to stdout/stderr" ON)
ENDIF()
OPTION(CLOG_BUILD_TESTS "Build clog tests" ON)

# ---[ CMake options
IF(CLOG_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

MACRO(CLOG_TARGET_RUNTIME_LIBRARY target)
  IF(MSVC AND NOT CLOG_RUNTIME_TYPE STREQUAL "default")
    IF(CLOG_RUNTIME_TYPE STREQUAL "shared")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MD$<$<CONFIG:Debug>:d>")
    ELSEIF(CLOG_RUNTIME_TYPE STREQUAL "static")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MT$<$<CONFIG:Debug>:d>")
    ENDIF()
  ENDIF()
ENDMACRO()

# ---[ clog library
ADD_LIBRARY(clog OBJECT src/clog.c)
SET_TARGET_PROPERTIES(clog PROPERTIES
  C_STANDARD 99
  C_EXTENSIONS NO)
CLOG_TARGET_RUNTIME_LIBRARY(clog)
SET_TARGET_PROPERTIES(clog PROPERTIES PUBLIC_HEADER include/clog.h)
TARGET_INCLUDE_DIRECTORIES(clog BEFORE PUBLIC include)
IF(CLOG_LOG_TO_STDIO)
  TARGET_COMPILE_DEFINITIONS(clog PRIVATE CLOG_LOG_TO_STDIO=1)
ELSE()
  TARGET_COMPILE_DEFINITIONS(clog PRIVATE CLOG_LOG_TO_STDIO=0)
ENDIF()

=== debian/changelog ===
svt-av1 (2.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.3.0+dfsg

 -- Dylan Aïssi <daissi@debian.org>  Fri, 13 Dec 2024 14:54:06 +0100

=== debian/control ===
Source: svt-av1
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               nasm | yasm
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/AOMediaCodec/SVT-AV1
Vcs-Browser: https://salsa.debian.org/multimedia-team/svt-av1
Vcs-Git: https://salsa.debian.org/multimedia-team/svt-av1.git

Package: svt-av1
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Scalable Video Technology for AV1 (SVT-AV1 Encoder)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder) is an
 AV1-compliant encoder library core. The SVT-AV1 encoder development
 is a work-in-progress targeting performance levels applicable to both VOD and
 Live encoding / transcoding video applications. The SVT-AV1 decoder
 implementation is targeting future codec research activities.

Package: libsvtav1enc2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Scalable Video Technology for AV1 (libsvtav1enc shared library)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder) is an
 AV1-compliant encoder library core. The SVT-AV1 encoder development
 is a work-in-progress targeting performance levels applicable to both VOD and
 Live encoding / transcoding video applications. The SVT-AV1 decoder
 implementation is targeting future codec research activities.
 .
 This package provides the shared library libsvtav1enc.

Package: libsvtav1enc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libsvtav1enc2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libsvtav1-dev (<< 2.1.2+dfsg-1~)
Replaces: libsvtav1-dev (<< 2.1.2+dfsg-1~)
Description: Scalable Video Technology for AV1 (libsvtav1enc development files)
 The Scalable Video Technology for AV1 (SVT-AV1 Encoder) is an
 AV1-compliant encoder library core. The SVT-AV1 encoder development
 is a work-in-progress targeting performance levels applicable to both VOD and
 Live encoding / transcoding video applications. The SVT-AV1 decoder
 implementation is targeting future codec research activities.
 .
 This package provides the development files for libsvtav1enc.

## svt-av1 3.0.2+dfsg

=== debian/changelog ===
svt-av1 (3.0.2+dfsg-1) experimental; urgency=medium

  * New upstream version 3.0.2+dfsg
  * Add libcpuinfo-dev in Build-Deps.
  * Bump SONAME to libsvtav1enc3.
  * Update symbols file.
  * Update debian/copyright.
  * Standards-Version: 4.7.2 (no changes needed).

 -- Dylan Aïssi <daissi@debian.org>  Sat, 24 May 2025 18:54:51 +0200

## svt-av1 3.1.0+dfsg

=== debian/changelog ===
svt-av1 (3.1.0+dfsg-1) experimental; urgency=medium

  * New upstream version 3.1.0+dfsg

 -- Dylan Aïssi <daissi@debian.org>  Fri, 01 Aug 2025 12:05:32 +0200

## svt-av1 3.1.2%2Bdfsg

=== Source/Lib/ASM_AVX2/CMakeLists.txt ===
#
# Copyright(c) 2019 Intel Corporation
#
# This source code is subject to the terms of the BSD 2 Clause License and
# the Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License
# was not distributed with this source code in the LICENSE file, you can
# obtain it at https://www.aomedia.org/license/software-license. If the Alliance for Open
# Media Patent License 1.0 was not distributed with this source code in the
# PATENTS file, you can obtain it at https://www.aomedia.org/license/patent-license.
#

# ASM_AVX2 Directory CMakeLists.txt

# Include Encoder Subdirectories
include_directories(${PROJECT_SOURCE_DIR}/Source/API/
    ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
    ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE2/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSSE3/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSE4_1/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX2/
    ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_AVX512/)
link_directories(${PROJECT_SOURCE_DIR}/Source/Lib/ASM_SSSE3/)

check_both_flags_add(-mavx2)

if(CMAKE_C_COMPILER_ID STREQUAL "Intel")
    if(WIN32)
        # Intel Windows (*Note - The Warning level /W0 should be made to /W4 at some point)
        check_both_flags_add(/Qdiag-disable:10010,10148,10157 /W0)
    else()
        check_both_flags_add(-static-intel -w)
    endif()
endif()

if(MSVC)
    check_both_flags_add(/arch:AVX2)
endif()

set(all_files
    aom_subpixel_8t_intrin_avx2.c
    av1_inv_txfm_avx2.c
    av1_inv_txfm_avx2.h
    av1_quantize_avx2.c
    blend_a64_mask_avx2.c
    cdef_avx2.c
    cdef_block_avx2.c
    cfl_avx2.c
    comb_avg_sad_intrin_avx2.c
    compute_sad_avx2.h
    compute_sad_intrin_avx2.c
    convolve_2d_avx2.c
    convolve_avx2.c
    convolve_avx2.h
    corner_match_avx2.c
    dwt_avx2.c
    encodetxb_avx2.c
    fft_avx2.c
    highbd_convolve_2d_avx2.c
    highbd_convolve_avx2.c
    highbd_fwd_txfm_avx2.c
    highbd_intra_pred_avx2.c
    highbd_inv_txfm_avx2.c
    highbd_jnt_convolve_avx2.c
    highbd_quantize_intrin_avx2.c
    highbd_variance_avx2.c
    highbd_warp_affine_avx2.c
    inter_prediction_com_avx2.c
    intra_pred_intrin_avx2.c
    itx_hbd.h
    itx_lbd.h
    jnt_convolve_2d_avx2.c
    jnt_convolve_avx2.c
    mc.h
    memory_avx2.h
    noise_model_avx2.c
    obmc_sad_avx2.c
    obmc_variance_avx2.c
    pack_unpack_intrinsic_avx2.c
    palette_avx2.c
    pickrst_avx2.c
    pickrst_avx2.h
    pic_operators_inline_avx2.h
    pic_operators_intrin_avx2.c
    resize_avx2.c
    restoration_pick_avx2.c
    selfguided_avx2.c
    sse_avx2.c
    ssim_avx2.c
    synonyms_avx2.h
    temporal_filtering_avx2.c
    transforms_intrin_avx2.c
    transpose_avx2.h
    txfm_common_avx2.h
    variance_avx2.c
    variance_impl_avx2.c
    warp_plane_avx2.c
    wiener_convolve_avx2.c
    wiener_convolve_avx2.h
    )

set(asm_files
    itx_avx2.asm
    itx16_avx2.asm
    mc_avx2.asm
    mc16_avx2.asm)
add_library(ASM_AVX2 OBJECT ${all_files})
asm_compile_to_target(ASM_AVX2 ${asm_files})

## svt-av1 3.1.2%2bdfsg

=== Source/Lib/ASM_NEON/CMakeLists.txt ===
#
# Copyright (c) 2023, Alliance for Open Media. All rights reserved
#
# This source code is subject to the terms of the BSD 2 Clause License and the
# Alliance for Open Media Patent License 1.0. If the BSD 2 Clause License was
# not distributed with this source code in the LICENSE file, you can obtain it
# at www.aomedia.org/license/software. If the Alliance for Open Media Patent
# License 1.0 was not distributed with this source code in the PATENTS file, you
# can obtain it at www.aomedia.org/license/patent.
#

# ASM_NEON Directory CMakeLists.txt

# Include Encoder Subdirectories
enable_language(ASM) # needed for .S files
add_library(ASM_NEON OBJECT)
target_sources(
  ASM_NEON
  PUBLIC aom_convolve8_neon.c
  PUBLIC aom_sum_squares_neon.c
  PUBLIC av1_inv_txfm_neon.c
  PUBLIC av1_inv_txfm_neon.c
  PUBLIC av1_k_means_neon.c
  PUBLIC av1_quantize_neon.c
  PUBLIC blend_a64_mask_neon.c
  PUBLIC block_error_neon.c
  PUBLIC cdef_block_neon.c
  PUBLIC cdef_filter_block_neon.c
  PUBLIC cdef_neon.c
  PUBLIC cfl_neon.c
  PUBLIC compound_convolve_neon.c
  PUBLIC compute_sad_neon.c
  PUBLIC convolve_neon.c
  PUBLIC convolve_scale_neon.c
  PUBLIC corner_match_neon.c
  PUBLIC dav1d_asm.S
  PUBLIC dav1d_util.S
  PUBLIC deblocking_filter_intrinsic_neon.c
  PUBLIC encodetxb_neon.c
  PUBLIC hadamard_path_neon.c
  PUBLIC highbd_blend_a64_mask_neon.c
  PUBLIC highbd_convolve_neon.c
  PUBLIC highbd_convolve_scale_neon.c
  PUBLIC highbd_fwd_txfm_neon.c
  PUBLIC highbd_inter_prediction_neon.c
  PUBLIC highbd_intra_prediction_neon.c
  PUBLIC highbd_inv_txfm_neon.c
  PUBLIC highbd_jnt_convolve_neon.c
  PUBLIC highbd_loopfilter_neon.c
  PUBLIC highbd_pickrst_neon.c
  PUBLIC highbd_quantize_neon.c
  PUBLIC highbd_sse_neon.c
  PUBLIC highbd_subtract_block_neon.c
  PUBLIC highbd_variance_neon.c
  PUBLIC highbd_warp_plane_neon.c
  PUBLIC highbd_wiener_convolve_neon.c
  PUBLIC inter_prediction_neon.c
  PUBLIC intra_prediction_neon.c
  PUBLIC itx.S
  PUBLIC obmc_sad_neon.c
  PUBLIC obmc_variance_neon.c
  PUBLIC pack_unpack_intrin_neon.c
  PUBLIC pic_analysis_neon.c
  PUBLIC pickrst_neon.c
  PUBLIC picture_operators_intrinsic_neon.c
  PUBLIC restoration_pick_neon.c
  PUBLIC sad_neon.c
  PUBLIC selfguided_neon.c
  PUBLIC sse_neon.c
  PUBLIC subtract_block_neon.c
  PUBLIC temporal_filtering_neon.c
  PUBLIC transforms_intrin_neon.c
  PUBLIC upsampled_pred_neon.c
  PUBLIC variance_neon.c
  PUBLIC warp_plane_neon.c
  PUBLIC wedge_utils_neon.c
  PUBLIC wiener_convolve_neon.c)

target_include_directories(
  ASM_NEON
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/API/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/Codec/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/C_DEFAULT/
  PRIVATE ${PROJECT_SOURCE_DIR}/Source/Lib/ASM_NEON/)
# Causes the files to be explicitly compiled with `-x c`, which is wrong.
# https://cmake.org/cmake/help/git-master/policy/CMP0119.html
# set_source_files_properties(dav1d_asm.S dav1d_util.S itx.S PROPERTIES LANGUAGE
#                                                                       C)
